// Learn TypeScript:
//  - [Chinese] https://docs.cocos.com/creator/manual/zh/scripting/typescript.html
//  - [English] http://www.cocos2d-x.org/docs/creator/manual/en/scripting/typescript.html
// Learn Attribute:
//  - [Chinese] https://docs.cocos.com/creator/manual/zh/scripting/reference/attributes.html
//  - [English] http://www.cocos2d-x.org/docs/creator/manual/en/scripting/reference/attributes.html
// Learn life-cycle callbacks:
//  - [Chinese] https://docs.cocos.com/creator/manual/zh/scripting/life-cycle-callbacks.html
//  - [English] http://www.cocos2d-x.org/docs/creator/manual/en/scripting/life-cycle-callbacks.html

const {ccclass, property} = cc._decorator;

@ccclass
export default class CoolDown extends cc.Component {

    @property(cc.ProgressBar)
    progressBar: cc.ProgressBar = null;

    _countDown: number = 10;
    _time: number = 0;
    _cd: boolean = false;
    _callback = null; 

    // LIFE-CYCLE CALLBACKS:

    // onLoad () {}

    start () {
        
    }

    setData(countDown,callback)
    {
        this._countDown = countDown;   
        this._callback = callback;
    }

    startCoolDown()
    {
        this._time = 0;
        this._cd = true;
    }

    update (dt) {
        if (!this._cd) {
            return;
        }

        this._time += dt;
        this.progressBar.progress = 1 - this._time / this._countDown;

        if (this._time > this._countDown) {
            this._cd = false;
            if (this._callback) {
                this._callback();
            }
        }
    }
}
